package com.small_it_office.flatserve.transition;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import com.small_it_office.flatserve.core.service.SessionRequired;

/**
 * ΏۂHTTPT[rX\bhsۂɁAۑꂽg[NƂċw肷Ame[VłB
 * {@link Token}Ame[VɂĒOɕۑꂽg[N̕񂪁AtokensvfɋLq̂̂ǂꂩA
 * ܂tokensStartsWithvfɎw肵ꂩ̕Ŏn܂ĂꍇɁAHTTPT[rX\bh̎s܂B
 * <p>
 * ȉ̗́Ag[N"foo"ۑĂꍇ̂ݎs\HTTPT[rX\bh\܂B
 * <pre>
 * &#064;HttpService
 * &#064;AllowedTokens(tokens = "foo")
 * public HtmlTextResponse serviceMethod1() {
 *     ...
 * </pre>
 * </p>
 * <p>
 * tokenśAw肷邱Ƃł܂B̏ꍇAw肳ꂽ̂̕ǂꂩPAۑꂽg[N
 * v΁AHTTPT[rX\bh̎s܂B
 * <pre>
 * &#064;HttpService
 * &#064;AllowedTokens(tokens = {"foo", "bar"})
 * public HtmlTextResponse serviceMethod2() {
 *     ...
 * </pre>
 * </p>
 * <p>
 * g[N̕rSvł͂ȂAOvōsƂł܂B
 * "hoge"A"hogehoge"A"fugafuga"Ƃg[ŃAȉ̎w̏Ɉv܂B
 * <pre>
 * &#064;HttpService
 * &#064;AllowedTokens(tokensStartsWith = {"hoge", "fuga"})
 * public HtmlTextResponse serviceMethod3() {
 *     ...
 * </pre>
 * </p>
 * <p>
 * tokensvftokensStartsWithvf͓Ɏw肷邱Ƃł܂B
 * ̗vfȗꍇAۑĂg[Nɂ炸
 * KsȑJڂƂ݂ȂĂ܂܂B
 * </p>
 */
@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
@SessionRequired
public @interface AllowedTokens {

	/**
	 * ۑĂg[Ňw肵܂B
	 * ۑĂg[NŎw肵̂ꂩɈv΁AJڂƂ݂Ȃ܂B
	 */
	String[] tokens() default {};

	/**
	 * ۑĂg[N̍ŏ̕w肵܂B
	 * ۑĂg[NAŎw肵̂ꂩŎn܂Ă΁AJڂƂ݂Ȃ܂B
	 */
	String[] tokensStartsWith() default {};
}
